unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, MyPlaylist, ComCtrls, Menus;

type
  TForm1 = class(TForm)
    MyPlaylist1: TMyPlaylist;
    OpenDialog1: TOpenDialog;
    OpenDialog2: TOpenDialog;
    OpenDialog3: TOpenDialog;
    TrackBar1: TTrackBar;
    FontDialog1: TFontDialog;
    btnAdd: TButton;
    btnRem: TButton;
    btnSel: TButton;
    pmAdd: TPopupMenu;
    File1: TMenuItem;
    Files1: TMenuItem;
    PLSPlaylist1: TMenuItem;
    M3UPlaylist1: TMenuItem;
    pmRem: TPopupMenu;
    Delete1: TMenuItem;
    Clear1: TMenuItem;
    pmSel: TPopupMenu;
    Selectall1: TMenuItem;
    Selectnone1: TMenuItem;
    Selectinvert1: TMenuItem;
    N1: TMenuItem;
    racking1: TMenuItem;
    btnMisc: TButton;
    pmMisc: TPopupMenu;
    Getpath1: TMenuItem;
    Gettrackingitemnumber1: TMenuItem;
    Getallfiles1: TMenuItem;
    Getitemscount1: TMenuItem;
    N2: TMenuItem;
    Columns1: TMenuItem;
    Number1: TMenuItem;
    Duration1: TMenuItem;
    Playlistfont1: TMenuItem;
    Colors1: TMenuItem;
    Background1: TMenuItem;
    Font1: TMenuItem;
    Selectedbackgrnd1: TMenuItem;
    Selectedfont1: TMenuItem;
    rackingbackground1: TMenuItem;
    rackingfont1: TMenuItem;
    ColorDialog1: TColorDialog;
    N3: TMenuItem;
    SaveM3U1: TMenuItem;
    SaveDialog1: TSaveDialog;
    procedure TrackBar1Change(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure btnAddMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure btnRemMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure btnSelMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure File1Click(Sender: TObject);
    procedure Files1Click(Sender: TObject);
    procedure PLSPlaylist1Click(Sender: TObject);
    procedure M3UPlaylist1Click(Sender: TObject);
    procedure DeleteClick(Sender: TObject);
    procedure TrackingClick(Sender: TObject);
    procedure Delete1Click(Sender: TObject);
    procedure Clear1Click(Sender: TObject);
    procedure racking1Click(Sender: TObject);
    procedure btnMiscMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure GetPathClick(Sender: TObject);
    procedure Getpath1Click(Sender: TObject);
    procedure Gettrackingitemnumber1Click(Sender: TObject);
    procedure Getallfiles1Click(Sender: TObject);
    procedure Getitemscount1Click(Sender: TObject);
    procedure Number1Click(Sender: TObject);
    procedure Duration1Click(Sender: TObject);
    procedure Playlistfont1Click(Sender: TObject);
    procedure Background1Click(Sender: TObject);
    procedure Font1Click(Sender: TObject);
    procedure Selectedbackgrnd1Click(Sender: TObject);
    procedure Selectedfont1Click(Sender: TObject);
    procedure rackingbackground1Click(Sender: TObject);
    procedure rackingfont1Click(Sender: TObject);
    procedure MyPlaylist1Paint(Sender: TObject);
    procedure SaveM3U1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses Unit2;

{$R *.dfm}

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
MyPlaylist1.SetPosition(TrackBar1.Position);
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
//if MyPlaylist1.Count > 0 then
//TrackBar1.Max := MyPlaylist1.Count - (MyPlaylist1.Height div MyPlaylist1.GetItemHeight)
end;

procedure TForm1.FormResize(Sender: TObject);
begin
MyPlaylist1.Left := 8;
MyPlaylist1.Top := 8;
MyPlaylist1.Width := Form1.ClientWidth-20;
TrackBar1.Left := Form1.ClientWidth - 17;
MyPlaylist1.Height := Form1.ClientHeight - 16 - btnAdd.Height;
TrackBar1.Height := Form1.ClientHeight - 16 - btnAdd.Height;
btnAdd.Top := MyPlaylist1.Top + MyPlaylist1.Height + 8;
btnRem.Top := MyPlaylist1.Top + MyPlaylist1.Height + 8;
btnSel.Top := MyPlaylist1.Top + MyPlaylist1.Height + 8;
btnMisc.Top := MyPlaylist1.Top + MyPlaylist1.Height + 8;
end;

procedure TForm1.btnAddMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
if button = mbleft then
pmAdd.Popup(Mouse.CursorPos.X, Mouse.CursorPos.Y);
end;

procedure TForm1.btnRemMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
if button = mbleft then
pmRem.Popup(Mouse.CursorPos.X, Mouse.CursorPos.Y);
end;

procedure TForm1.btnSelMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
if button = mbleft then
pmSel.Popup(Mouse.CursorPos.X, Mouse.CursorPos.Y);
end;

procedure TForm1.File1Click(Sender: TObject);
begin
if not OpenDialog1.Execute then exit;
MyPlaylist1.Add_File(OpenDialog1.FileName);
end;

procedure TForm1.Files1Click(Sender: TObject);
begin
if not OpenDialog2.Execute then exit;
MyPlaylist1.Add_Files(OpenDialog2.Files);
end;

procedure TForm1.PLSPlaylist1Click(Sender: TObject);
begin
if not OpenDialog3.Execute then exit;
MyPlaylist1.LoadPlaylist_PLS(OpenDialog3.FileName);
end;

procedure TForm1.M3UPlaylist1Click(Sender: TObject);
begin
if not OpenDialog3.Execute then exit;
MyPlaylist1.LoadPlaylist_M3U(OpenDialog3.FileName);
end;

procedure TForm1.DeleteClick(Sender: TObject);
begin
Form1.MyPlaylist1.Delete_Item(StrToInt(Form2.Edit1.Text));
Form2.Close;
Form2.Edit1.Text := '';
end;

procedure TForm1.TrackingClick(Sender: TObject);
begin
Form1.MyPlaylist1.SetNewItemTrack(StrToInt(Form2.Edit1.Text));
Form2.Close;
Form2.Edit1.Text := '';
end;

procedure Delete;
begin
Form2.Caption := 'Delete item';
Form2.Label1.Caption := 'Delete:';
Form2.Button1.OnClick := Form1.DeleteClick;
Form2.ShowModal
end;

procedure TForm1.Delete1Click(Sender: TObject);
begin
Delete;
end;

procedure TForm1.Clear1Click(Sender: TObject);
begin
MyPlaylist1.ClearList;
end;

procedure Tracking;
begin
Form2.Caption := 'Set tracking item';
Form2.Label1.Caption := 'Tracking:';
Form2.Button1.OnClick := Form1.TrackingClick;
Form2.ShowModal
end;

procedure TForm1.racking1Click(Sender: TObject);
begin
Tracking;
end;

procedure TForm1.btnMiscMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
if button = mbleft then
pmMisc.Popup(Mouse.CursorPos.X, Mouse.CursorPos.Y);
end;

procedure GetPath;
begin
Form2.Caption := 'Get item path';
Form2.Label1.Caption := 'Item #:';
Form2.Button1.OnClick := Form1.GetPathClick;
Form2.ShowModal
end;

procedure TForm1.GetPathClick(Sender: TObject);
begin
ShowMessage(Form1.MyPlaylist1.GetItemFiles[StrToInt(Form2.Edit1.Text)]);
Form2.Close;
Form2.Edit1.Text := '';
end;

procedure TForm1.Getpath1Click(Sender: TObject);
begin
GetPath;
end;

procedure TForm1.Gettrackingitemnumber1Click(Sender: TObject);
begin
ShowMessage(IntToStr(MyPlaylist1.GetTracking));
end;

procedure TForm1.Getallfiles1Click(Sender: TObject);
var
s: string;
i: integer;
begin
for i := 0 to MyPlaylist1.Count-1 do
begin
s:= s+#13+MyPlaylist1.GetItemFiles[i];
end;
ShowMessage(s);
end;

procedure TForm1.Getitemscount1Click(Sender: TObject);
begin
ShowMessage(IntToStr(MyPlaylist1.Count))
end;

procedure TForm1.Number1Click(Sender: TObject);
begin
if Number1.Checked then
number1.Checked := False
else
number1.Checked := True;

MyPlaylist1.ShowNumber := Number1.Checked
end;

procedure TForm1.Duration1Click(Sender: TObject);
begin
begin
if Duration1.Checked then
Duration1.Checked := False
else
Duration1.Checked := True;

MyPlaylist1.ShowDuration := Duration1.Checked
end;

end;

procedure TForm1.Playlistfont1Click(Sender: TObject);
begin
FontDialog1.Font := MyPlaylist1.Font;
if not FontDialog1.Execute then exit;
MyPlaylist1.Font := FontDialog1.Font
end;

procedure TForm1.Background1Click(Sender: TObject);
begin
ColorDialog1.Color := MyPlaylist1.Item_BackColor;
if not ColorDialog1.Execute then exit;
myPlaylist1.Item_BackColor := ColorDialog1.Color;
end;

procedure TForm1.Font1Click(Sender: TObject);
begin
ColorDialog1.Color := MyPlaylist1.Item_FontColor;
if not ColorDialog1.Execute then exit;
myPlaylist1.Item_FontColor := ColorDialog1.Color;
end;

procedure TForm1.Selectedbackgrnd1Click(Sender: TObject);
begin
ColorDialog1.Color := MyPlaylist1.ItemSelect_BackColor;
if not ColorDialog1.Execute then exit;
myPlaylist1.ItemSelect_BackColor := ColorDialog1.Color;
end;

procedure TForm1.Selectedfont1Click(Sender: TObject);
begin
ColorDialog1.Color := MyPlaylist1.ItemSelect_FontColor;
if not ColorDialog1.Execute then exit;
myPlaylist1.ItemSelect_FontColor := ColorDialog1.Color;
end;

procedure TForm1.rackingbackground1Click(Sender: TObject);
begin
ColorDialog1.Color := MyPlaylist1.ItemTrack_BackColor;
if not ColorDialog1.Execute then exit;
myPlaylist1.ItemTrack_BackColor := ColorDialog1.Color;
end;

procedure TForm1.rackingfont1Click(Sender: TObject);
begin
ColorDialog1.Color := MyPlaylist1.ItemTrack_FontColor;
if not ColorDialog1.Execute then exit;
myPlaylist1.ItemTrack_FontColor := ColorDialog1.Color;
end;

procedure TForm1.MyPlaylist1Paint(Sender: TObject);
begin
if MyPlaylist1.Count > 0 then
TrackBar1.Max := MyPlaylist1.Count - (MyPlaylist1.Height div MyPlaylist1.GetItemHeight)
end;

procedure TForm1.SaveM3U1Click(Sender: TObject);
begin
if MessageDlg('Full path?', mtInformation, [mbYes, mbNo], 0) = mrYes then
begin
if not SaveDialog1.Execute then exit;
MyPlaylist1.SavePlaylist_M3U(SaveDialog1.FileName,True);
end else
begin
if not SaveDialog1.Execute then exit;
MyPlaylist1.SavePlaylist_M3U(SaveDialog1.FileName,False);
end;
end;

end.
